#===============================================================================
# Class
#
class Class
	# attr_set_once
	def attr_set_once(*atts)
		atts.each do |att|
			att = att.to_s
			
			# set
			define_method("#{att}=") do |val|
				if instance_variable_defined?("@#{att}")
					raise 'set-once-instance-variable-already-set: ' + att
				else
					instance_variable_set "@#{att}", val
				end
			end
			
			# get
			define_method("#{att}") do
				if instance_variable_defined?("@#{att}")
					return instance_variable_get("@#{att}")
				else
					return nil
				end
			end
		end
	end
end
#
# Class
#===============================================================================